// OEP  6
// Maurice Clerc, mars 2004

// Bibliothques
//#include "stdafx.h"    // Pour Windows
#include <math.h>
#include <stdio.h>
#include <stdlib.h>

// Valeurs 
#define ulong unsigned long // Pour gnration de nombres pseudo-alatoires
#define RAND_MAX_KISS ((unsigned long) 4294967295)
#define D_max 201 // Dimension maximale de l'espace de recherche
#define	N_max 50 // Taille maximale de l'essaim
#define  K_max 200 // Nombre maximum d'informatrices
#define C_max 11  // Nombre maximum de contraintes indicatives + 1  (cots)
#define presquezero 0.00000000001
#define sigmoid(x_)	1.0 / (1.0 + exp(-(x_)))

// Structures
struct	cout	{int taille;double c[C_max];};
struct	position {int taille;double x[D_max]; struct cout C;};
struct	vecteur	{int taille;double v[D_max];};
struct	matrice {int ligne;int colonne;int lien[N_max][N_max];};
struct param {int pivot;double unif;int fige;int reine;int M1;int M2;int 
parall;int reorg;double phi1;double phi2;double d_phi;int K1;int K2;int N1;int 
N2;int equivalence;int 
equivalence_floue;int confin_interv;int info_topologie;int info_option;double 
pr;int mouv_option;int adapt_c1;int energie;};
struct	probleme {int sauve_exec;int fonction;int contrainte;int n_exec_max;int 
eval_max;int C_taille;int D;double xmin[D_max];double xmax[D_max];double delta[D_max];double 
fmin;double eps; };


// Sous-programmes

double	alea(double a,double b);
int		alea_entier(int a,int b);
double alea_normal(double moyenne, double ecart);
struct vecteur alea_proxim(struct vecteur v, double coeff1, double coeff2, int option);
struct vecteur alea_sphere(int D, double rayon,double unif);
double	alea_volume(int D);
double	coeff_SC(int D);
int		compare_cout (struct cout C1,struct cout C2, double eps);
double	distance(struct position pos1, struct position pos2);
double	energie_c();
double	energie_p();
double	erreur(struct cout C);
void	info_liens(int N, int M,int K, int info_option,double pr);
double	max(double a,double b);
double	min(double a,double b);
int		ma_contrainte(struct position x,int contrainte);
struct	cout ma_fonction (struct position x, int fonction);
struct param param(FILE *f_param);
struct probleme probleme(FILE *f_probleme);
ulong	rand_kiss();
double	regranul(double x,double granul);
struct position	respect_contrainte(struct position pos, struct position x_n,int 
contrainte);
double	scalaire(struct vecteur v1,struct vecteur v2);
void	seed_rand_kiss(ulong seed);
void	sauve_liens(FILE *f,int option);
double	zero_(double valeur);


//static double net(double *inputs, struct position weights);
double ANNSINSIMP(struct position weights);
double ANNParity4(struct position weights);
double ANNXor(struct position weights);
#include "annsinsimp.c"
#include "annparity.c"
#include "annxor.c"

// Variables globales
int		amelioration;

char	blanc[1]="";
double	E; // exp(1);
int		FIN; // 1, en cas de fin prmature
int		graine; // Pour la fonction rand()
int		limite_precision; // Indicateur de limitation de prcision
int		M; // Taille de l'essaim-mmoire
int		N;			// Taille de l'essaim
int		nb_eval; // Nombre total d'valuations
int		n_suiv; // Pour info. Numro de la particule  suivre
struct position EX_P[N_max];	// Essaim explorateur, positions
struct vecteur	EX_V[N_max];	// Essaim exlorateur, vitesses
struct position EM_P[N_max][2]; // Essaim-mmoire, positions.
                                // Il y en a deux pour l'option parallele
struct position EX0_P[N_max]; // Essaim explorateur, positions avant mouvements
								// Juste pour tudes dynamiques
struct	matrice LIENS; // Codage :
						// 1:= un lien EM=>EX 
						// -1:= un lien EM=>EM 
						// 2:= les deux
double			omega;
struct position	pos;
struct probleme P;
struct param p;
double	pi; // Le nombre pi
double	precision;
struct position x_p,x_n;
double	zero;
double compte=0;

FILE *f_graph_dot;
FILE *f_graph_dot_simple;
FILE *f_energ;
FILE *f_exec;
FILE *f_param;
FILE *f_perf;
FILE *f_pos;
FILE *f_probleme;
FILE *f_robust;
FILE *f_synthese;

int main()
{
//struct vecteur alea_i,alea_g;
double	c,c1,c1_0,cmax;	// Coefficients de confiance
double	c2,c3;
double	coeff_S_C;
int		d;			// Numro de la dimension courante
double	delta,delta0;
double	eps_moyen;
double	eval_moyen;	// Nombre moyen d'valuations
double	fm;
double	fn;

double	f1,f2,f3;
double	fp1,fp2;
int		g;			// Numro de la meilleure informatrice
int		g2;
int		K;			// Taille des groupes d'informatrices
double	lambda;
struct	position meilleure;	// Mmorisation de la toute meilleure position trouve
struct	position meilleure_meilleure; // Meilleure sur plusieurs excutions
int      meilleure_rang;
struct	cout	min_C,min2_C;
int		m,m1,m2,m3;
int		mn;

int		n;			// Numro de la particule courante
int		n_echec;
int		n_exec;
int		n_problem,nb_problem;
double	phi;
double	pid;
double	pgd;

double	rho;
struct	position reine;
int		respect;
int		sens;
struct position	temp;
double	unif;
struct	vecteur vi,vg,vtemp1,vtemp2;
double	x;
double	z,zz;

E=exp(1);
pi=acos(-1);
f_graph_dot=fopen("graph_dot.txt","w"); // Graphe des liens au format dot
f_graph_dot_simple=fopen("graph_dot_simple.txt","w"); // Graphe simplifi
f_exec=fopen("exec.txt","w"); // Sauvegarde des rsultats de l'excution
f_energ=fopen("energies.txt","w"); // Pour info. Energies cintique et potentielle
f_param=fopen("param.txt","r"); // Paramtres de fonctionnement
f_perf=fopen("perf.txt","w"); // Sauvegarde des performances des particules de 
								// l'essaim-mmoire
f_pos=fopen("pos.txt","w"); // Sauvegarde des positions
f_probleme=fopen("probleme.txt","r"); // Donnes du problme
f_robust=fopen("robust.txt","w"); // Sauvegarde pour tudes de robustesse
f_synthese=fopen("synthese.txt","w"); // Sauvegarde des rsultats globaux
fprintf(f_synthese,"\nFonction Essaim M c1 cmax Essais Eval_moyen eps_moyen echec valeur_min");

graine=1;


// Options de fonctionnement
zero=pow(10,-323);  // Utile si limite_precision>0 et en cas de contrainte 
					// indicative
limite_precision=0; // Si 1, vitesse min=zero

p=param(f_param);// Lecture des paramtres de fonctionnement

fscanf(f_probleme,"%i",&nb_problem);

if (FIN==1) return 0;


for (n_problem=0;n_problem<nb_problem;n_problem++)
{
	srand(graine); // Initialise le calcul des nombres pseudo-alatoires
	seed_rand_kiss(graine);

	P=probleme(f_probleme); // Description du problme et de l'effort de recherche

	// Calculs pour quivalence de volumes sphre-cube
	// On prend une valeur moyenne entre les cas D pair et D impair

	coeff_S_C=coeff_SC(P.D);

	// On considre un D-cube de diagonale 2*r
	// et une D-sphre dforme dont un diamtre est 2*r
	// et tous les autres omega*2*r
	// omega est calcul de faon  ce que leurs volumes 
	// soient gaux

	if (P.D==1) omega=1;
	else 
	{
		x=(double)P.D;
		z=x/(x-1);
		omega=pow(2*coeff_S_C/sqrt(x),z);
	}

printf("\n Dimension %i  => coeff_S_C %f, omega %f",P.D,coeff_S_C, omega);

for (phi=p.phi1;phi<=p.phi2;phi=phi+p.d_phi) // ----------- phi
{
	fprintf(f_robust,"\nfonction %i",P.fonction);
for (K=p.K1;K<=p.K2;K++) // ----------Nombre de liens d'information K 
					// (pour info_option=12, c'est juste un minimum
{

	fprintf(f_robust,"\nK %i",K);
for (M=p.M1;M<=p.M2;M++)
{
	fprintf(f_robust,"\n%f ",phi);

for (N=p.N1;N<=p.N2;N++)  // ------------------Taille de l'essaim N
{
	if (p.info_option!=5 && p.info_option>0 && M>N)
	{
		printf("\n ERREUR. Avec info_option=%i, vous ne pouvez avoir M>N\n",p.info_option);
		return 0;
	}

	if (p.M1<0) M=N; // Pour cartes de performance avec M=N	

	info_liens(N,M,K,p.info_option,p.pr); // Met  jour la structure de liens
	if (FIN==1) return 0;

	if (p.info_option<=1 || p.info_option==3) // Cas o il y a des choix au hasard
	{
		printf("\n La structure de liens n'est pas constante");
	}

	// Sauvegarde au format dot. Visualisation par exemple avec Graphviz
	sauve_liens(f_graph_dot,1);
	sauve_liens(f_graph_dot_simple,2);


	if (p.info_topologie>0) 	return 0;// On veut juste avoir la topologie des liens


//mouvement:
printf("\n Essaim %i particules",N);

	// Calcul des coefficients de confiance
	c1=1/(phi-1+sqrtf(phi*phi-2*phi));
	cmax=c1*phi;

printf("  c1=%f, cmax=%f",c1,cmax);
//printf("\n coeff_S_C %f", coeff_S_C); return 0;

printf("\n--------------------------------------------");

n_exec=0;
eval_moyen=0;
eps_moyen=0;
n_echec=0;

c1_0=c1;

init: 

//	srand(graine); // Initialise le calcul des nombres pseudo-alatoires
//	seed_rand_kiss(graine);

// Eventuellement, modif des liens  chaque nouvelle excution
	if (p.fige==2 && n_exec>0) 
		info_liens(N,M,K,p.info_option,p.pr); 

// Initialisations des positions et vitesses
fprintf(f_pos,"\n\n");
n_exec=n_exec+1;
for (n=0;n<N;n++)
{
	EX_P[n].taille=P.D;  EX_P[n].C.taille=P.C_taille;
	for (d=0;d<P.D;d++) 
	{
		z=alea(P.xmin[d],P.xmax[d]);
		EX_P[n].x[d]=regranul(z,P.delta[d]);	
	}
	EX_V[n].taille=P.D;
	for (d=0;d<P.D;d++) 
		EX_V[n].v[d]=alea((P.xmin[d]-P.xmax[d])/2,(P.xmax[d]-P.xmin[d])/2);
}


 /*
for (n=0;n<N;n++) // Sauvegarde des positions initiales
{
	fprintf(f_exec,"\n");
	for (d=0;d<P.D;d++) fprintf(f_exec," %f ",EX_P[n].x[d] );
}
fprintf(f_exec,"\n\n");
  */


  
// Eventuellement, dplacement pour respecter la contrainte
if (P.contrainte>0)
{
	for (n=0;n<N;n++)
	{
		respect=ma_contrainte(EX_P[n],P.contrainte);
		if (respect==0)
		{	
			EX_P[n]=respect_contrainte(EX_P[n], x_n,P.contrainte);
		}
	}

}

// Evaluations initiales

for (m=0;m<M;m++) 

for (d=0;d<P.C_taille;d++)
	EM_P[m][0].C.c[d]=1/zero; // Ceci pour viter que dans le cas o
							// mmoire n'est informe par aucune exploratrice
							// elle soit mise  zro par dfaut
nb_eval=0;
amelioration=0; 


for (n=0;n<N;n++) // Pour chaque particule
{		
	EX_P[n].C=ma_fonction(EX_P[n],P.fonction); // Evaluation de la position

	for (m=0;m<M;m++)  //  Mmorisation de la position
	{
		if (LIENS.lien[m][n]==1 || LIENS.lien[m][n]==0) continue;
			EM_P[m][0]=EX_P[n]; // Meilleure position = position initiale
	}
}

//printf("\n Init. nb_eval %i",nb_eval);
// Mmorisation du meilleur rsultat atteint jusqu'ici
meilleure=EM_P[0][0];
meilleure_rang=0;
if (n_exec==1) meilleure_meilleure=meilleure;
for (m=1;m<M;m++)
{ 
	if (compare_cout(EM_P[m][0].C,meilleure.C,P.eps)==1)
   {meilleure=EM_P[m][0];   meilleure_rang=m;}
}

 if (p.parall==1)    // Double stockage si parallelisme
 {  
	 for (m=0;m<M;m++) EM_P[m][1]=EM_P[m][0];
 } 


 delta=erreur(meilleure.C);
printf("\n meilleure aprs initialisation %i => %f",meilleure_rang,delta);



if (p.energie>0) fprintf(f_energ,"\n%i %f %f",nb_eval,energie_c(),energie_p());


boucle:  // -------------------------------------------------------------------- ITERATIONS

fprintf(f_pos,"\n%f",delta);

delta0=delta; // Pour tester si l'itration apporte une amlioration
for (n=0;n<N;n++) EX0_P[n]=EX_P[n]; // Stockage pour tudes dynamiques
									
		 
for (n=0;n<N;n++) // Pour chaque particule ...
{	
	// Recherche de la mmoire associe  n
	if (p.info_option==99) {mn=n; goto deux_m;} // Simulation OEP0 (ncessite N=M)

	for (m=0;m<M;m++)

	{
		if (LIENS.lien[m][n]==2 ) 
		{mn=m; goto deux_m;}
	}
	printf("\n ERREUR. Pas de mmoire associe  %i",n); printf("\n");
deux_m:

	// Recherche des deux meilleures informatrices
	for (m=0;m<M;m++)
	{
		if (LIENS.lien[m][n]>0)
		{
			g=m; min_C=EM_P[m][0].C;  
			g2=m;min2_C=min_C;
			goto suite_inform;
		}
	}
suite_inform:
		if(g<M-1)
		{
		for (m=g+1;m<M;m++)
		{
			if (LIENS.lien[m][n]<=0) continue;

			if (compare_cout(EM_P[m][0].C,min_C,P.eps)==1) {g=m;min_C=EM_P[m][0].C;}

			else
			if (compare_cout(EM_P[m][0].C,min2_C,P.eps)==1) {g2=m;min2_C=EM_P[m][0].C;}
		}
		}

	// Calcul de la nouvelle vitesse


	switch(p.adapt_c1) // Adaptation ventuelle du coefficient c1
	{
	default:
		break;
	case 1:
		c1=c1*0.999999;
		break;
	case 2:
		fn=erreur(EX_P[n].C);
		c1=c1_0*(1-exp(P.fmin-fn));
		break;
	}

// Recherche du prochain point
	vtemp1.taille=P.D;  vtemp2.taille=P.D;
	 for (d=0;d<P.D;d++) 
     {             		
		vtemp1.v[d]=EM_P[mn][p.parall].x[d]-EX_P[n].x[d]; // P-X
        vtemp2.v[d]=EM_P[g][p.parall].x[d]-EX_P[n].x[d]; // G-X
      }

	switch(p.mouv_option)
	{
     case 0: // OEP classique "historique" (D-rectangles)
	mouv_option0:
		vi=alea_proxim(vtemp1,cmax,p.unif,0);
		vg=alea_proxim(vtemp2,cmax,p.unif,0);
		// Cumul et complment et ajout de la composante dpendant de la vitesse
		for (d=0;d<P.D;d++) EX_V[n].v[d]=c1*EX_V[n].v[d]+vi.v[d]+vg.v[d];
		break;

	case 1: // Secteurs ellipsodaux positifs
	mouv_option1:
		lambda=coeff_S_C*cmax; // Mathmatique
//lambda=0.5+0.1*(P.D-1); // Empirique pour phi=2.07

		vi=alea_proxim(vtemp1,lambda,p.unif,1);
		vg=alea_proxim(vtemp2,lambda,p.unif,1);
		for (d=0;d<P.D;d++) EX_V[n].v[d]=c1*EX_V[n].v[d]+vi.v[d]+vg.v[d];
		break;

	case 101: goto mouv_option1; // Mauvais

	case 2: // Gaussiennes indpendantes
	mouv_option2:
		vi=alea_proxim(vtemp1,cmax/2,cmax/4,2);
		vg=alea_proxim(vtemp2,cmax/2,cmax/4,2);
		for (d=0;d<P.D;d++) EX_V[n].v[d]=c1*EX_V[n].v[d]+vi.v[d]+vg.v[d]; 

		
		break;

	case 3: // Pivots
	mouv_option3:
		unif=p.unif;
		lambda=1;
	mouv_option3a:
		rho=distance(EM_P[mn][p.parall],EM_P[g][p.parall]);

		vi=alea_sphere(P.D,rho,unif); 
		vg=alea_sphere(P.D,rho,unif);

		fp1=erreur(EM_P[mn][p.parall].C);
		fp2=erreur(EM_P[g][p.parall].C);
		f1=1/fp1; f2=1/fp2; f3=f1+f2; f1=f1/f3; f2=f2/f3;

  		for (d = 0;d<P.D;d++) 
		{
			pid=EM_P[mn][p.parall].x[d];
			pgd=EM_P[g][p.parall].x[d];
			temp.x[d]  = f1*(vi.v[d]+pid) + f2*(vg.v[d]+pgd); // Nouvelle position
			temp.x[d]=temp.x[d]*lambda; // Bruit ventuel
			EX_V[n].v[d]=temp.x[d]-EX_P[n].x[d]; // Vitesse
		}
		break;

	case 4: // Pivots avec bruit
	mouv_option4:
		z=(fp1-fp2)/(fp1+fp2);
		lambda=1+alea_normal(0,z);
		unif=1;
		goto mouv_option3a;

	case 5: // Ellipsodes orients
	mouv_option5:
		//z=cmax/2;
		z=cmax;

		vi=alea_proxim(vtemp1,z,p.unif,5);
		vg=alea_proxim(vtemp2,z,p.unif,5);

		for (d=0;d<P.D;d++) EX_V[n].v[d]=c1*EX_V[n].v[d]+vi.v[d]+vg.v[d];
		break;

	case 6: // Combinaison
			// rectangles si amlioration,
			// pivots sinon
		if (amelioration==1) goto mouv_option0; else goto mouv_option3;

	case 7: // Combinaison *
			// secteurs ellipsodaux positifs si amlioration,
			// pivots sinon
		if (amelioration==1) goto mouv_option1; else goto mouv_option3;

	case 8: // Combinaison
			// secteurs ellipsodaux positifs si PAS d'amlioration,

			// pivots sinon
		if (amelioration==0) goto mouv_option1; else goto mouv_option3;

	case 9: // Combinaison
			// Ellipsodes si amlioration 
			// Gaussiennes indpendantes sinon
		if (amelioration==1) goto mouv_option5; else goto mouv_option2;

	case 10: // Combinaison *
			// Ellipsodes si PAS amlioration 
			// Gaussiennes indpendantes sinon
		if (amelioration==1) goto mouv_option2; else goto mouv_option5;

	case 11: // Combinaison *
			// pivots bruits si amlioration 
			// pivots sinon
		if (amelioration==1) goto mouv_option4; else goto mouv_option3;

	case 12: // Combinaison 
			// secteurs ellipsodaux positifs si amlioration,
			// pivots bruits sinon
		if (amelioration==1) goto mouv_option1; else goto mouv_option4;

	case 13: // Combinaison
			// rectangles si amlioration,
			// pivots bruits sinon
		if (amelioration==1) goto mouv_option0; else goto mouv_option4;
	
	case 14: // Combinaison
			// Gaussiennes indpendantes si amlioration
			// pivots bruits sinon
		if (amelioration==1) goto mouv_option2; else goto mouv_option4;

	case 15: // Combinaison *
			// pivots si amlioration 
			// pivots bruits sinon
		if (amelioration==1) goto mouv_option3; else goto mouv_option4;

	case 16 : // Combinaison *
			// pivots bruits si amlioration 
			// gaussiennes indpendantes sinon
		if (amelioration==1) goto mouv_option4; else goto mouv_option2;

  case 98: //D-segments
		vi=alea_proxim(vtemp1,cmax,p.unif,98);
		vg=alea_proxim(vtemp2,cmax,p.unif,98);

		// Cumul et complment et ajout de la composante dpendant de la vitesse
		for (d=0;d<P.D;d++) EX_V[n].v[d]=c1*EX_V[n].v[d]+vi.v[d]+vg.v[d];
		break;

  case 99: // D-rectangle sur le vecteur moyen
      for (d=0;d<P.D;d++) vtemp1.v[d] =0.5*(vtemp1.v[d]+vtemp2.v[d]);
      vi=alea_proxim(vtemp1,cmax,p.unif,0);
      for (d=0;d<P.D;d++) EX_V[n].v[d]=c1*EX_V[n].v[d]+vi.v[d];
      break;

  default:       goto 	mouv_option0;

	} // Fin switch(p.mouv_option)

	// Dplacement
	x_n=EX_P[n]; // Avant dplacement, x_n respecte l'ventuelle contrainte
//fprintf(f_exec,"\n x_n");	 for (d=0;d<P.D;d++) fprintf(f_exec," %f",EX_P[n].x[d]);

	for (d=0;d<P.D;d++) EX_P[n].x[d]=EX_P[n].x[d]+EX_V[n].v[d];

confinement:	
	// Eventuellement, re-dplacement pour respecter la contrainte
	if (P.contrainte>0) 
	{	
		respect=ma_contrainte(EX_P[n],P.contrainte);
		if (respect==0)
		{
			EX_P[n]=respect_contrainte(EX_P[n], x_n,P.contrainte);
		}

	}
 
  
	// Confinement d'intervalle
	// Note : ce n'est pas forcment une bonne ide que de donner des intervalles de valeur 
	// finemement ajusts. Cela restreint la libert de manoeuvre des particules.
	switch(p.confin_interv) 
	{
  case -1: break; // Pas de confinement
  case 0: // avec annulation de la vitesse
		for (d=0;d<P.D;d++) 
		{
			if (EX_P[n].x[d]<P.xmin[d]) {EX_P[n].x[d]=P.xmin[d];EX_V[n].v[d]=0;}
			if (EX_P[n].x[d]>P.xmax[d]) {EX_P[n].x[d]=P.xmax[d];EX_V[n].v[d]=0;}
		}
		break;
	default: // avec renversement partiel de la vitesse
		for (d=0;d<P.D;d++) 
		{
  		if (EX_P[n].x[d]<P.xmin[d]) {EX_P[n].x[d]=P.xmin[d];EX_V[n].v[d]=-0.5*EX_V[n].v[d];}
			if (EX_P[n].x[d]>P.xmax[d]) {EX_P[n].x[d]=P.xmax[d];EX_V[n].v[d]=-0.5*EX_V[n].v[d];}			
		}
		break;
	}
 
		// Confinement de granularit
   for (d=0;d<P.D;d++)
   {
          if(P.delta[d]>0)
             EX_P[n].x[d]=regranul(EX_P[n].x[d],P.delta[d]);
   }

	// Evaluation de la nouvelle position
	EX_P[n].C=ma_fonction(EX_P[n],P.fonction);
 
	// Mise  jour de la meilleure position
	//recherche les particules-mmoire  informer
	
		for (m=0;m<M;m++) // Pour toute m particule de EM ...
		{
			if(LIENS.lien[m][n]==0 ||LIENS.lien[m][n]==1 ) continue; // ... qui doit tre informe ...
				if (compare_cout(EX_P[n].C,EM_P[m][p.parall].C,P.eps)==1) // ... si amlioration ...
				{
                           EM_P[m][p.parall]=EX_P[n]; // ... on mmorise
                           if (compare_cout(EM_P[m][p.parall].C,meilleure.C,P.eps)==1)
                                 meilleure=EM_P[m][p.parall];    meilleure_rang=m;
				}
		}

} // Fin boucle sur les particules n

// Deuxime phase. Modifications ventuelles des mmoires
// Groupe d'information circulaire.

delta=erreur(meilleure.C);

// if (p.reorg==1)
if (p.reorg==1 && delta<delta0)
{ 
   for (m=0;m<M;m++) // Mthode 2. Lgre rduction de la diversit . NON parallle !
   {
      // => BON ?
      // Si les deux mmoires voisines sont meilleures, on s'aligne sur une des deux
      // choisie au hasard

      m1=m+1; if (m1>M-1) m1=0;
      m2=m-1; if (m2<0) m2=M-1;

         if (compare_cout(EM_P[m1][p.parall].C,EM_P[m][p.parall].C,P.eps)==1 && compare_cout(EM_P[m2][p.parall].C,EM_P[m][p.parall].C,P.eps)==1)		 
         {
            g=alea_entier(0,1);
            if (g==0) EM_P[m][p.parall]=EM_P[m1][p.parall];	else EM_P[m][p.parall]=EM_P[m2][p.parall];
         }
      }
}

if (p.reorg==2)
{ 
   for (m=0;m<M;m++) // Mthode 3. Lgre rduction de la diversit . NON parallle !
   {
      // => BON ?
      // Si les deux mmoires tires au sort sont meilleures, on s'aligne sur une des deux
      // choisie au hasard

      m1=alea_entier(0,M-1);
      m2=alea_entier(0,M-1);
         if (compare_cout(EM_P[m1][p.parall].C,EM_P[m][p.parall].C,P.eps)==1 && compare_cout(EM_P[m2][p.parall].C,EM_P[m][p.parall].C,P.eps)==1)		 
         {
            g=alea_entier(0,1);
            if (g==0) EM_P[m][p.parall]=EM_P[m1][p.parall];	else EM_P[m][p.parall]=EM_P[m2][p.parall];
         }
      }
}

if (p.reorg==3)
{ 
	c3=erreur(EM_P[0][p.parall].C); m3=0;

	c2=c3;m2=m3;
   for (m=1;m<M;m++) // Mthode 3. Lgre rduction de la diversit . NON parallle !
   {

		c=erreur(EM_P[m][p.parall].C);
		if (c>c3) {c3=c; m3=m;}
		if (c<c2) {c2=c; m2=m;}
    }

  // m=alea_entier(0,M-1);   EM_P[m3][p.parall]=EM_P[m][p.parall];
			
   EM_P[m3][p.parall]=EM_P[m2][p.parall];

}

if (p.reorg==4)
{ 
	c3=erreur(EM_P[0][p.parall].C); m3=0; // la pire
	c2=c3;m2=m3; // la meilleure
   for (m=1;m<M;m++) // NON parallle !
   {
		c=erreur(EM_P[m][p.parall].C);
		if (c>c3) {c3=c; m3=m;}
		if (c<c2) {c2=c; m2=m;}
    }

	// m3=alea_entier(0,M-1);   
	temp=EM_P[m3][p.parall];
	EM_P[m3][p.parall]=EM_P[m2][p.parall];
	EM_P[m2][p.parall]=temp;

}


if (p.reine>0 && M>1)
{
	reine=EM_P[0][p.parall];

	switch (p.reine)
	{
	case 1: // Sans pondration
		z=M;
		for (m=1;m<M;m++)
		{
			for (d=0;d<P.D;d++)
			{
				reine.x[d]=reine.x[d]+EM_P[m][p.parall].x[d];
			}
		}
	break;

	case 2: // Avec pondration
		z=0;
		reine.taille=P.D;
		for (d=0;d<P.D;d++) reine.x[d]=0;
		for (m=0;m<M;m++)
		{
			zz=erreur(EM_P[m][p.parall].C);
			z=z+zz;

			for (d=0;d<P.D;d++)
			{
				reine.x[d]=reine.x[d]+zz*EM_P[m][p.parall].x[d];
			}
		}

	}
	for (d=0;d<P.D;d++) reine.x[d]=reine.x[d]/z; 
	reine.C=ma_fonction(reine,P.fonction); // Evaluation
	if (compare_cout(reine.C,meilleure.C,P.eps)==1) // Remplacement ventuel
	{meilleure=reine; EM_P[0][p.parall]=reine;}
} // fin reine


// Test de fin
delta=erreur(meilleure.C);
if (delta<delta0) amelioration=1; else amelioration=0; // Indicateur pour combinaison rgule
											// 1 => il y a eu amlioration
//printf("\n amelioration %i",amelioration);


if (p.energie>0) fprintf(f_energ,"\n%i %f %f",nb_eval,energie_c(),energie_p());

if (fabs(delta-P.fmin)>P.eps && nb_eval<P.eval_max)
 {
     if (p.parall==1)    // Mise a jour du stockage si parallelisme
     {
        for (m=0;m<M;m++) EM_P[m][0]=EM_P[m][1];
     } 
	
	if(p.reorg==3) goto boucle; // Il y a eu brassage de mmoires
								// il ne faut pas modifier les liens
	if(p.reorg==4) goto boucle; // Idem
	if (p.fige<0) goto boucle;
	if (p.fige>1) goto boucle; // Les liens ne sont pas modifis  chaque itration
//	if (p.fige==1 && delta<=delta0) goto boucle;// Ils ne sont pas modifis si amlioration
												// ou statu quo

	if (p.fige==1 && delta<delta0) goto boucle;
	if (p.info_option<=1 ||   p.info_option==3)// Ils sont modifis  
    {
       info_liens(N,M,K,p.info_option,p.pr);    
     }
    goto boucle;
 }
if (fabs(delta-P.fmin)>P.eps) n_echec=n_echec+1;

/*
if(n_suiv>=0)
{// Suivi de la particule n_suiv
fprintf(f_pos,"\n");
for (d=0;d<P.D;d++) // Pour chaque dimension ...
{
		fprintf(f_pos," %f",EX_P[n_suiv].x[d]);
}
fn=erreur(EX_P[n_suiv].C); // Position courante
fprintf(f_pos," %f  ",fn);

for (d=0;d<P.D;d++) // Pour chaque dimension ...
{
		fprintf(f_pos," %f",EM_P[n_suiv][p.parall].x[d]);
}
fm=erreur(EM_P[n_suiv][p.parall].C); // Mmoire (dans le cas o elle a le mme rang)
fprintf(f_pos," %f  ",fm);

}
*/



// Affichage du meilleur rsultat trouv
printf("\n%i. Eval= %i : \n",n_exec,nb_eval);
printf(" Meilleure particule %i : \n",meilleure_rang);
for (d=0;d<meilleure.C.taille;d++) printf(" %.10f",meilleure.C.c[d]);
printf("\n Position : "); for (d=0;d<P.D;d++) printf(" %f",meilleure.x[d]);



eval_moyen=eval_moyen+nb_eval;
eps_moyen=eps_moyen+fabs(delta-P.fmin);


// Sauvegarde du meilleur rsultat
if (P.sauve_exec>0)
{
	fprintf(f_exec,"\n%i %i / ",n_exec,nb_eval);
	for (d=0;d<meilleure.C.taille;d++) fprintf(f_exec," %.10f",meilleure.C.c[d]);
	fprintf(f_exec," / ");

	for (d=0;d<P.D;d++) fprintf(f_exec," %.10f",meilleure.x[d]);
}

// Affichage du taux d'chec courant

printf("\n                          Taux d'echec = %f", n_echec/(double)n_exec);


// Boucle ventuelle si excutions multiples
if(n_exec>1)
{

	if(compare_cout(meilleure.C,meilleure_meilleure.C,P.eps)==1) 
		meilleure_meilleure=meilleure;
}	
 
   if (n_exec<P.n_exec_max) goto init;
   
eval_moyen=eval_moyen/(double)n_exec;
eps_moyen=eps_moyen/(double)n_exec;
printf("\n Nb d'executions = %i",n_exec);

printf("\n Eval moyen = %f",eval_moyen);
printf("\n Eps moyen = %f",eps_moyen);
printf("\n Taux d'echec = %f", n_echec/(double)n_exec);
if (n_exec>1)
{
	printf("\n Meilleure meilleure :");
	printf("\n Defaut : ");
   for (d=0;d<meilleure_meilleure.C.taille;d++) printf(" %.12f",meilleure_meilleure.C.c[d]);
	printf("\n Position : "); for (d=0;d<P.D;d++) printf(" %f",meilleure_meilleure.x[d]);
}

fprintf(f_synthese,"\n %i",P.fonction);
fprintf(f_synthese," %i",N);
 fprintf(f_synthese," %i",M);
fprintf(f_synthese," %f",c1);


fprintf(f_synthese," %f",cmax);
fprintf(f_synthese," %i",P.n_exec_max);
fprintf(f_synthese," %f",eval_moyen);
fprintf(f_synthese," %f",eps_moyen);
fprintf(f_synthese," %f", n_echec/(double)n_exec);
for (d=0;d<meilleure_meilleure.C.taille;d++) 
	fprintf(f_synthese," %.12f",meilleure_meilleure.C.c[d]);

fprintf(f_robust," %f",n_echec/(double)n_exec);

//printf("\n bidon %i",bidon);


} // boucle sur N
} // boucle sur M
} // boucle sur K
} // boucle sur phi
} // boucle sur les problmes

fclose(f_synthese);

return 0;
}


//============================================================= ALEA

double	alea(double a,double b)
{
double 	r;

//r=(double)rand()/(double)RAND_MAX;
	r=(double)rand_kiss()/RAND_MAX_KISS;
	r=a+(b-a)*r;
	return r;
}
//============================================================= ALEA_ENTIER 
int	alea_entier(int a,int b)
{// Dlivre un nombre entier au hasard entre a et b
int		ir;
double 	r;

r=alea(0,1);
ir=(int)(a+r*(b+1-a));
if (ir>b) ir=b;

//printf("\n %i %i %i",a,b,ir);
return ir;

}
//============================================================= ALEA_NORMAL
double alea_normal(double moyenne, double ecart)

 {
 /*
     Utilise la forme polaire de la transformation de Box-Muller
     pour obtenir un nombre pseudo aleatoire selon une distribution
     gaussienne
 */
	double x1, x2, w, y1;

         do {
                 x1 = 2.0 * alea(0,1) - 1.0;
                 x2 = 2.0 * alea(0,1) - 1.0;
                 w = x1 * x1 + x2 * x2;
         } while ( w >= 1.0);

         w = sqrt( -2.0 * log( w ) / w );
         y1 = x1 * w;
        // y2 = x2 * w;
          y1=y1*ecart+moyenne;
         return y1;
  }

// ------------------------------------------------------------------------- ALEA_PROXIM
struct vecteur alea_proxim(struct vecteur v,double coeff1,double coeff2, int option)
{
struct	vecteur	alea_s;

int				d;
double			lambda;
struct	vecteur proxim;
double			rho;
double			volume;
struct	vecteur	vtemp,vtemp2;
double			coeff_omega=0.318; // 0.5
double			z,zz;

proxim.taille=v.taille;

switch (option)

{
case 0: // D-rectangle
	for (d=0;d<proxim.taille;d++)  proxim.v[d]=alea(0,coeff1)*v.v[d]; // coeff1=cmax
	break;

case 98: // Segment
        z= alea(0,coeff1); // coeff1=cmax
      for (d=0;d<proxim.taille;d++) proxim.v[d]=z*v.v[d]; 
	break;

case 1: // D-secteur positif ellipsodal
case_1:
	alea_s=alea_sphere(proxim.taille, coeff1, coeff2); // coeff1=rayon, coeff2= uniformit

	for (d=0;d<proxim.taille;d++) proxim.v[d]=fabs(alea_s.v[d])*v.v[d];
	break;

	case 101: // D-secteur positif ellipsodal invers. Mauvais
	case_101:
	alea_s=alea_sphere(proxim.taille, coeff1, coeff2); // coeff1=rayon, coeff2= uniformit

	for (d=0;d<proxim.taille;d++) proxim.v[d]=(coeff1-fabs(alea_s.v[d]))*v.v[d];
	break;


case 2: //  Gaussiennes indpendantes
	// coeff1= moyenne, coeff2=cart-type
		for (d=0;d<proxim.taille;d++) 	//proxim.v[d]=coeff1*fabs(alea_normal(0.5,coeff2))*v.v[d];
		{
			z=alea_normal(coeff1,coeff2);
			proxim.v[d]=z*v.v[d];
//printf("\n %f", z);
		}
		break;

case 5: // Ellipsodes orients

	rho=0.5*coeff1*sqrt(scalaire(v,v));

	if (rho<=0)
	{
		for (d=0;d<proxim.taille;d++) proxim.v[d]=0;
		return proxim;
	}
	
	alea_s=alea_sphere(proxim.taille, rho,coeff2); // M-O, O centre de la sphre

	vtemp2.taille=v.taille;
	for (d=0;d<proxim.taille;d++) vtemp2.v[d]=coeff1*v.v[d];
	for (d=0;d<proxim.taille;d++) vtemp.v[d]=alea_s.v[d]+0.5*vtemp2.v[d]; // M-X=M-O + O-X

	lambda=scalaire(vtemp2,vtemp)/(4*rho*rho);

	for (d=0;d<P.D;d++) vtemp.v[d]=vtemp.v[d]-lambda*vtemp2.v[d]; // Vecteur normal  P"-X
	
	// Dplacement M'-X
	z=P.D;
	volume=z*log(2/sqrt(z)); // Log du volume max possible pour le D-rectangle

									// (ramen au cas rho=1)


zz=alea_volume(P.D); // Volume alatoire (log)  (pour rho=1)
//printf("\n %f %f ",volume,zz);
	zz=(zz-volume)/(z-1); // Ajustement pour l'ellipsode
	coeff_omega=exp(zz); 	
//coeff_omega=2*coeff_omega;
//coeff_omega=0.7;
													
//printf("\n %f %f %f %f",zz,coeff_omega, omega, coeff_omega*omega);
//lambda=pow(lambda,0.33);

	for (d=0;d<P.D;d++) 
     { 
        proxim.v[d]=lambda*vtemp2.v[d]+coeff_omega*omega*vtemp.v[d];
		//proxim.v[d]=(0.6+0.4*lambda)*vtemp2.v[d]+coeff_omega*omega*vtemp.v[d]; // Avec dcalage
	}
	break;

default:
	printf("\n ERREUR. L'option de proximit %i n'est pas traite",option); 
}

return proxim;
}

// ------------------------------------------------------------------------- ALEA_SPHERE
struct vecteur alea_sphere(int D, double rayon,double unif)
{
/*  Fournit un point au hasard dans une (hyper)sphre
 Maurice Clerc 2003-07-11

Centre 0
unif=1 => distribution uniforme
unif>0 mais # 1 => distribution non uniforme
unif <0 => gaussienne, avec cart-type=abs(unif)

*/

int 	j;
double   l;
double      pw;
double      r;
 double     sigma;
struct	vecteur	x;

x.taille=D;
pw=1/(double)D;

// ----------------------------------- Etape 1.  Direction alatoire
//  C'est un thorme ...
    l=0;
   for (j=0;j<D;j++)
   {
          x.v[j]=alea_normal(0,1);
          l=l+  x.v[j]*x.v[j];
   }

   l=sqrt(l);

 //----------------------------------- Etape 2.   Rayon alatoire
   if (unif>0)  
 {
    r=alea(0,1);
    r=pow(r,pw*unif);
  }
  else
  {
        sigma=-unif;
        r=fabs(alea_normal(0,sigma));

		r=pow(r,pw);
  }

       for (j=0;j<D;j++)
   {

          x.v[j]=rayon*r*x.v[j]/l;
//printf("\n %f %f",x.v[j],alea(0,1));
   }
return x;
}

// ------------------------------------------------------------------------- ALEA_VOLUME
double alea_volume(int D)
{
	/*
Donne le volume d'un D-rectangle alatoire de diagonale 1
Pour viter les problmes de prcision, on renvoie en fait le log

  */
double	volume;
int		d;
double	s;
struct	vecteur	x;

// Direction alatoire
s=0;
for(d=0;d<D;d++) 
{
	x.v[d]=alea_normal(0,1);
	s=s+x.v[d]*x.v[d];
}

// Normalisation
s=sqrt(s);
for(d=0;d<D;d++) x.v[d]=x.v[d]/s;	

// Volume quivalent (son logarithme)
volume=0;
for(d=0;d<D;d++) volume=volume+log(fabs(x.v[d]));

return volume;

}

//============================================================= COEFF_SC
double coeff_SC(int D)
{

	// Le D-cube d'arte a
	// et la D-sphre de rayon r=a*coeff_S_C
	// ont le mme volume
	double coeff;
	double	c1,c2;
	int		d;
	double	d3;
	double	x;

	int option=1; // 0 => valeur exacte
				// 1 => valeur moyenne **

if (D==1) return 0.5;


	x=(double)D;
	if ((2*(int)(D/2)==D) || option==1) // D pair
	{
		d3=1; for (d=2;d<=P.D/2;d++) d3=d3*d; // (D/2)!
		c1=pow(d3,1/x)/sqrt(pi); 

		if (option==0) return c1;
	}

	 // D impair
	{
		d3=1; for (d=2;d<=P.D;d++) d3=d3*d; // D!
		c2=0.5*pow(d3,1/x)/pow(pi,0.5-0.5/x);
		if (option==0) return c2;
	}

	coeff=(c1+c2)/2;

return coeff;
}
//============================================================= COMPARE_COUT
int		compare_cout(struct cout C1,struct cout C2, double eps)
{/*
 Renvoie	0 si C2 meilleure que C1
			1 si C1 meilleure que C2
			2 si C1=C2

C1 et C2 sont supposes de mme taille
*/
double	er;
int		c;

double	coeff;
double	delta;
double	max_C;
double	pr;
double	pr_equiv;

coeff=1;
er=eps/P.C_taille; // Erreur admissible moyenne

for (c=0;c<P.C_taille;c++)
{
	if(p.equivalence==1)
	{
	// Test_1 
	// Si les deux couts d'indice c sont admissibles
	// on les considre comme quivalents
		if (C1.c[c]<er && C2.c[c]<er) continue;
	}

	if(p.equivalence_floue>0)
	{
	// Test_2
	// Plus l'cart est petit, plus ils sont probablement quivalents
		delta=fabs(C1.c[c]-C2.c[c]);
		max_C=max(C1.c[c],C2.c[c]);
		pr_equiv=pow((max_C-delta)/max_C,p.equivalence_floue);
		pr=alea(0,1);
		if(pr<pr_equiv) continue;
	}

		if (C1.c[c]<C2.c[c]) return 1;
		if (C2.c[c]<C1.c[c]) return 0;
}	
return 2;
}

// ----------------------------------------------------------------------------- DISTANCE
double	distance(struct position pos1,struct position pos2)

{
// Distance entre deux vecteurs positions
// Ils sont supposs avoir la mme dimension
double 	d,dx;
int		i;
d=0;
for (i=0;i<pos1.taille;i++)
{
	dx=pos1.x[i]-pos2.x[i];
	d=d+dx*dx;
}
d=sqrt(d);
return d;
}

//============================================================= ENERGIE_C
double	energie_c()
{
	// nergie cintique de l'essaim
	int		d;
	double	e;
	int		n;
	double	z;

e=0;
for (n=0;n<N;n++)
{
	for (d=0;d<P.D;d++)
	{
		z=EX_V[n].v[d];
		e=e+z*z;
	}
}

return e/2;


}

//============================================================= ENERGIE_P
double	energie_p()
{
	// nergie potentielle de l'essaim
	double	p;
	int		n;
	double	z;

p=0;
for (n=0;n<N;n++)
{
		z=erreur(EX_P[n].C);
		p=p+z;
}

return p/P.eps;

}
//============================================================= ERREUR
double erreur(struct cout C)
{
/*
Calcule l'erreur totale
*/
int c;
double e;
e=0;
for(c=0;c<P.C_taille;c++) e=e+C.c[c];
//printf("\nerreur() %f",e);
return e;
}

 

 //============================================================= INFO_LIENS
void info_liens(int N, int M,int K, int info_option, double pr)
{
/*
Dfinit les groupes d'informatrices dans l'essaim (variable globale LIENS)
 */
	
	int		FM[K_max]; // "frquences de communication pour les mmoires
	int		FN[N_max]; // "frquences" de communication pour les particules
	int		nF; // Nombre de frquences
	int		inform[N_max];

	double	inform_proba[N_max];
	int		inform_taille;
	int	k;
	int	m,m1,m2,m3;
	int		MF[K_max];
	int	n,n1,n2,n3,nf;
	int		NF[N_max];
	int	rang;
	int signe;
	double	z,zz;

	for (m=0;m<M;m++) for (n=0;n<N;n++) LIENS.lien[m][n]=0; // Initialisation

switch(info_option)
{
	case -3: // Hasard total

	for (n=0;n<N;n++) // Lien symtrique n <-> m
	{
		m=alea_entier(0,M-1);
		LIENS.lien[m][n]=2; 
	}

         for(m=0;m<M;m++) // Autres liens mmoire => particule
         {
			for (k=0;k<K;k++)
			{
				n=alea_entier(0,N-1);
              // if (LIENS.lien[m][n]!=2)  LIENS.lien[m][n]=1;
		LIENS.lien[m][n]=2;
			}
         }
		break;
case -2: // Tire au hasard les frquences de communication 
		// Suppose N>K. Sans intrt si N<2K (car alors nF=1)
		// Tous liens symtriques

	m=0; n=0; n1=0;m1=0;
		// Lien(s) symtrique(s)  particule <->mmoire

case__2_1:
		LIENS.lien[m][n]=2; 
		n=n+1; if (n==N) {n=0;n1=1;} // Toutes les particules sont lies  une mmoire
		m=m+1; if (m==M) {m=0;m1=1;} // Toutes les mmoires sont lies  une particule
		if (n1*m1==0) goto case__2_1;


	nF=(int)(double)N/(double)K;
	for (n=0;n<N;n++) FN[n]=alea_entier(1,nF);
	for (m=0;m<M;m++) FM[m]=alea_entier(1,nF);

	// Relie les particules et mmoires de mme frquence

	  for(m=0;m<M;m++)
	  {
		for (n=0;n<N;n++) if (FN[n]==FM[m]) LIENS.lien[m][n]=2;
	  }
	break;
	
case -1: // Tire au hasard les frquences de communication 
		// Suppose N>K
	nF=(int)(double)N/(double)K;
	for (n=0;n<N;n++) FN[n]=alea_entier(1,nF);
	for (m=0;m<M;m++) FM[m]=alea_entier(1,nF);



	// Relie les particules et mmoires de mme frquence, m -> n

	for (nf=1;nf<=nF;nf++)
	{

		n1=0; // Liste des exploratrices de frquence nf
		for (n=0;n<N;n++) if (FN[n]==nf) {NF[n1]=n;n1=n1+1;}
		m1=0; // Liste des mmoires de frquence nf
		for (m=0;m<M;m++) if (FM[m]==nf) {MF[m1]=m;m1=m1+1;}
//printf("\n %i %i %i",nf,n1,m1);		
		// Liens mmoire -> exploratrice
		if (m1>0)

		{
			for (m=0;m<m1;m++)
				for (n=0;n<n1;n++) LIENS.lien[MF[m]][NF[n]]=1;
		}
/*
		if(n1>0)
		{
			// Liens exploratrice <-> mmoire
			// Toute exploratrice doit informer au moins une mmoire
			if (m1>0)
			{
			n2=0;m2=0; n3=0; m3=0;
case__1_1:
			n=NF[n2];m=MF[m2];
//printf("\n nf %i.  n %i <-> m %i",nf,n,m);
			LIENS.lien[m][n]=2;
			n2=n2+1; if (n2==n1) {n2=0;n3=1;}
			m2=m2+1; if (m2==m1) {m2=0;m3=1;}
			if (n3*m3==0) goto case__1_1;
			}
			else // Il n'y a pas de mmoire de frquence nf
				// on en prend au hasard
			{
				for (n2=0;n2<n1;n2++)
				{
					n=NF[n2]; m=alea_entier(0,M-1);
					LIENS.lien[m][n]=2;
				}
			}
		}
*/
	}


		m=0; n=0; n1=0;m1=0;
	  case__1_2:
		LIENS.lien[m][n]=2; 
		n=n+1; if (n==N) {n=0;n1=1;} // Toutes les particules sont lies  une mmoire
		m=m+1; if (m==M) {m=0;m1=1;} // Toutes les mmoires sont lies  une particule
		if (n1*m1==0) goto case__1_2;


	break;


case 0: // Pour chaque particule-mmoire, tire au hasard K informes, avec remise *
case_0:
		m=0; n=0; n1=0;m1=0;
				// Lien(s) symtrique(s)  particule<=>mmoire
case_0_1:
		LIENS.lien[m][n]=2; 
		n=n+1; if (n==N) {n=0;n1=1;} // Toutes les particules sont lies  une mmoire
		m=m+1; if (m==M) {m=0;m1=1; }// Toutes les mmoires sont lies  une particule
		if (n1*m1==0) goto case_0_1;

         for(m=0;m<M;m++) // Autres liens mmoire => particule
         {
			for (k=0;k<K;k++)
			{
				n=alea_entier(0,N-1);
               if (LIENS.lien[m][n]!=2) LIENS.lien[m][n]=1;
			}
         }
		break;

case 1: // Pour chaque exploratrice, tire au hasard K mmoires (informatrices)
		m=0; n=0; n1=0;m1=0;
				// Lien(s) symtrique(s)  particule<=>mmoire
case_1_1:
		LIENS.lien[m][n]=2; 
		n=n+1; if (n==N) {n=0;n1=1;} // Toutes les particules sont lies  une mmoire
		m=m+1; if (m==M) {m=0;m1=1; }// Toutes les mmoires sont lies  une particule
		if (n1*m1==0) goto case_1_1;


         for(n=0;n<N;n++) // Autres liens mmoire => particule
         {
			for (k=0;k<K;k++)
			{
				m=alea_entier(0,M-1);
               if (LIENS.lien[m][n]!=2) LIENS.lien[m][n]=1;
			}
         }
		 break;


case 99: // Simulation OEP0. Ncessite N=M

         for(m=0;m<N;m++) 
         {	
			LIENS.lien[m][m]=2;
			 for (k=0;k<K;k++)
			{
				n=alea_entier(0,N-1);LIENS.lien[m][n]=2;
			}
         }
		 break;


case 2: // i-groupe circulaire de taille K.  Essaim-explorateur EX + essaim-mmoire EM
case_2:
		m=0; n=0; n1=0;m1=0;
					// Lien(s) symtrique(s)  particule<=>mmoire

case_2_1:
		LIENS.lien[m][n]=2; 
		n=n+1; if (n==N) {n=0;n1=1;} // Toutes les particules sont lies  une mmoire
		m=m+1; if (m==M) {m=0;m1=1; }// Toutes les mmoires sont lies  une particule
		if (n1*m1==0) goto case_2_1;
	if(N==1) goto case_2_2;
	if(K==1) goto case_2_2;

for (n=0;n<N;n++)  
{
   k=1;signe=1;n1=0;
boucle_2:
		rang=n+k*signe;
		if (rang>N-1) rang=rang-N;
		if (rang<0) rang=N+rang;
    
             LIENS.lien[rang][n]=1;   // Lien EM => EX

		n1=n1+1;
		if (n1==K-1) continue;
               signe=-signe; if (signe==1) k=k+1;	
               goto boucle_2;
}
case_2_2:
if(info_option==7) goto case_7;
if(info_option==11) goto case_11;	
break;
  
case 22: // Agrgats.  Essaim-explorateur EX + essaim-mmoire EM
		//  N=n1*M
	printf("\n info_option %i  complter dans info_liens()\n",info_option);
FIN=1; break;
/*
     	for (n=0;n<N;n++) P[n].i_groupe_taille=0; // EM => EX
      	for (n=0;n<M;n++) P_m[n].i_groupe_taille=0; // EX => EM

		n1=N/M;n3=0;n_fin=n1;

for (n=0;n<M;n++) // Pour chaque agrgat ... 
{
	for(n2=n3;n2<n_fin;n2++) // ... pour chaque particule
	{
		for(m=0;m<M;m++) // pour les particules-mmoire associes
		{
		rang=n+m;
		if (rang>=n1-1) rang=rang-n1+1;
		P[n2].i_groupe[P[n2].i_groupe_taille]=rang; // Lien EM => EX    n => rang
		P[n2].i_groupe_taille=P[n2].i_groupe_taille+1;

        P_m[rang].i_groupe[P_m[rang].i_groupe_taille]=n2; // Lien  EX => EM
        P_m[rang].i_groupe_taille=P_m[rang].i_groupe_taille+1;
		}
	}
	n3=n_fin;
	n_fin=n_fin+n1;
}

	break;
  */


case 3: // Pour chaque particule-memoire, tire au hasard K informees, avec remise
         for(m=0;m<M;m++)
         {
            for (k=0;k<K;k++)
            {
			n=alea_entier(0,N-1);
                  LIENS.lien[m][n]=1;
               }
         }
         // Pour chaque particule, choix au hasard d'une particule-memoire  a informer
         for(n=0;n<N;n++)
         {
               m=alea_entier(0,M-1);
               k= LIENS.lien[m][n] ;

               if (k==1) LIENS.lien[m][n]=2; else LIENS.lien[m][n]=-1;
          }
            // On complete pour les memoires non utilisees
         for(m=0;m<M;m++)  // Parcours des memoires
         {
            for(n=0;n<N;n++)   // Parcours des particules
            {
               if (LIENS.lien[m][n] ==2 || LIENS.lien[m][n]==-1) goto suite_m_3;
            }
            // La memoire m n'est pas utilisee, on lui affecte une particule au hasard
            n=alea_entier(0,N-1);
             LIENS.lien[m][n]=-1;
    suite_m_3: ;       
           }     
		break ;

case 4: // Graphe de relations de type "petit monde autosimilaire"
printf("\n info_option %i  complter dans info_liens()\n",info_option);
FIN=1; break;
 /*     
 n2=0; n_fin=n2 ;
 niveau_4:
 for (n=0;n<=n2;n++) 
 {
          // ... ajout d'un sous graphe fortement connexe
          n_fin=graph_f_connexe(n,n_fin,K); // Cre les liens dans l'essaim. Incrmente n_fin
		  if(n_fin>=N-1) goto fin_cas_4;

 
  }
  n2=n_fin;
  goto niveau_4;
  
fin_cas_4:
      break;
*/

case 51: // Graphe du type hirarchique
	printf("\n info_option %i  complter dans info_liens()\n",info_option);
FIN=1; break;
/*

n1=0;n2=0; n_fin=0; // Structure d'arbre

niveau_5:
for (n=n1;n<=n2;n++)
{
	for (k=1;k<K;k++)
	{
		rang=n_fin+k;
		if (rang>N-1) goto fin_cas_5;
		LIENS.lien[m][rang]=2;
printf("\ninfo_liens %i %i",m,rang);
	}
	n_fin=n_fin+K-1;

}

 n1=n2+1;
 n2=n_fin;
 goto niveau_5;

fin_cas_5:
	break;

*/

case 5: //M Etoiles interconnnectes;
m=0; 
if (M<=N) m2=M; else m2=N;
for (n=0;n<N;n++)
{
	 LIENS.lien[m][n]=2; // Lien symtrique
	if (m2==1) continue;
	n1=1;
	signe=1;
	for (k=1;k<K;k++)
	{
      m1=m+signe*n1;
	  if (m1<0) m1=m2+m1;
	  if (m1>=M) m1=m1-m2;
		if (m1!=m) LIENS.lien[m1][n]=1;   // Lien EM => EX

	  signe=-signe;
	  if (signe>0) n1=n1+1;
	}

	m=m+1;

	if (m==M) m=0;
}

if (M<=N) break;

// Il y a plus de mmoires que de particules
// On complte les liens


n=0; m=N;
complete_5:

	//if (LIENS.lien[m][n]==1) 
		LIENS.lien[m][n]=2 ;
	//	else LIENS.lien[m][n]=-1;
//printf("\n %i -> %i = %i",m,n,LIENS.lien[m][n]);
	n=n+1; if (n>=N) n=0;
	m=m+1; if (m<M) goto complete_5;
  break;

case 6: // Graphe de type tribus compltes
printf("\n info_option %i  complter dans info_liens()\n",info_option);
FIN=1; break;
/*
 n1=0;n2=N-1 ;

 for (n=n1;n<=n2;n=n+K)   // Regroupements par tribus
 {

          // ... ajout d'un sous graphe fortement connexe
          n_fin=graph_f_connexe(n,n,K); // Cre les liens dans l'essaim. Incrmente n_fin
          if(n_fin>=N-1) goto suite_cas_6;
  }
suite_cas_6 :


  // Cycles entre tribus

for (k=0;k<K;k++)
{
	for (n=k;n<N;n=n+K)
	{
		rang=n+K;
		if (rang>N-1) rang=k;

		P[n].i_groupe[P[n].i_groupe_taille]=rang; // Lien direct    n => rang
		P[n].i_groupe_taille=P[n].i_groupe_taille+1;
		P[rang].i_groupe[P[rang].i_groupe_taille]=n; // Lien symtrique
		P[rang].i_groupe_taille=P[rang].i_groupe_taille+1;
	}


}

	break;
*/

case 7: // Tribus circulaires fortement liees
	printf("\n info_option %i  complter dans info_liens()\n",info_option);
FIN=1; break;

	goto case_2;
case_7:
/*
 for (n=0;n<N;n++)
 {
	n1= P[n].i_groupe[K-1];
	n2= P[n].i_groupe[K-2];

	P[n1].i_groupe[P[n1].i_groupe_taille]=n2; // Lien direct    n => rang
	P[n1].i_groupe_taille=P[n1].i_groupe_taille+1;
	P[n2].i_groupe[P[n2].i_groupe_taille]=n1; // Lien symtrique
	P[n2].i_groupe_taille=P[n2].i_groupe_taille+1;
 }

	break;
*/

case 8: // Tribus hierarchiques  faiblement liees
	printf("\n info_option %i  complter dans info_liens()\n",info_option);
FIN=1; break;
/*

      for (n=0;n<N;n=n+K)  // Formation des tribus
      { 
         for (n1=n+1;n1<n+K;n1++ ) // Tribu hierarchique
         {
               if(n1>N-1) goto suite_8;
               P[n].i_groupe[P[n].i_groupe_taille]=n1; // Lien direct    n => n1
               P[n].i_groupe_taille=P[n].i_groupe_taille+1;
               P[n1].i_groupe[P[n1].i_groupe_taille]=n; // Lien inverse    n1 => n
               P[n1].i_groupe_taille=P[n1].i_groupe_taille+1;
         }
      }
      suite_8:

      for (n=0;n<N;n=n+K) // Lien circulaire entre tribus 
      {
         rang=n+K;    if(rang>N-1) rang=0; 
         P[n].i_groupe[P[n].i_groupe_taille]=rang; // Lien direct    n => rang

         P[n].i_groupe_taille=P[n].i_groupe_taille+1;
          //P[rang].i_groupe[P[rang].i_groupe_taille]=n; // Lien inverse    rang => n
         //P[rang].i_groupe_taille=P[rang].i_groupe_taille+1;     
         }

      break;
*/
case 9: // Tribus circulaires   faiblement lies
	printf("\n info_option %i  complter dans info_liens()\n",info_option);
FIN=1; break;
/*
      for (n=0;n<N;n=n+K)  // Formation des tribus
      {

		  for (n1=n;n1<n+K;n1++ ) // Tribu circulaire
         {
			rang=n1+1;
			if(rang>=n+K && rang<N) {rang=n; goto ajout_9;}
			if(rang==N &&  rang==n+2) goto suite_9;
			if (rang==N && rang>n+2) rang=n;

ajout_9:
            P[n1].i_groupe[P[n1].i_groupe_taille]=rang; // Lien direct n1 => rang
            P[n1].i_groupe_taille=P[n1].i_groupe_taille+1;
            P[rang].i_groupe[P[rang].i_groupe_taille]=n1; // Lien inverse rang => n1
            P[rang].i_groupe_taille=P[rang].i_groupe_taille+1;
         }
      }
    suite_9:

      for (n=0;n<N;n=n+K) // Lien circulaire entre tribus 
      {
         rang=n+K;    if(rang>N-1) rang=0;
         P[n].i_groupe[P[n].i_groupe_taille]=rang; // Lien direct    n => rang
         P[n].i_groupe_taille=P[n].i_groupe_taille+1;
         //P[rang].i_groupe[P[rang].i_groupe_taille]=n; // Lien inverse    rang => n
         //P[rang].i_groupe_taille=P[rang].i_groupe_taille+1;
         }
      break;
*/
case 10: // Tribus circulaires faiblement lies (2)
 for (n=0;n<N;n++) LIENS.lien[n][n]=2; // Auto-liens (on doit avoir M>=N)
      for (n=0;n<N;n=n+K)  // Formation des tribus
      {

		  for (n1=n;n1<n+K;n1++ ) // Tribu circulaire
         {
			rang=n1+1;
			if(rang>=n+K && rang<N) {rang=n; goto ajout_10;}

			if(rang==N &&  rang==n+2) goto suite_10;
			if (rang==N && rang>n+2) rang=n;

ajout_10:
			LIENS.lien[n1][rang]=1;
			LIENS.lien[rang][n1]=1;
         }
      }
    suite_10:
      for (n=0;n<N;n=n+K) // Lien circulaire entre tribus 
      {
         rang=n-1;    if(rang<0) rang=N-1;
		LIENS.lien[n][rang]=1;
		LIENS.lien[rang][n]=1;
         }
      break;

case 11: // "petit monde" par recblage alatoire (cf. Pour la Science, juin 2003)
	// Note : c'est  revoir, faire en parallle plutt qu'en squentiel.
	// (faire une copie de LIENS avant,  modifier la copie pendant,
	// faire copie inverse aprs)
	// Ne semble pas trs efficace, de toutes faons
	goto case_2;

case_11:
	for (m=0;m<M;m++)
	{
		for (n=0;n<N;n++)
		{
			
			m1=LIENS.lien[m][n];
			
			if (m1==0) continue; // Pas de lien ni dans un sens ni dans l'autre

				zz=alea(0,1);
				if (zz>pr) continue; // On ne modifie qu'avec une certaine probabilit
				m2=m1;
switch_m1:
//printf("\n m %i n %i m1 %i",m,n,m1);
			switch (m1)
			{
			case -1: // lien  n-> m
//printf("\n cas -1: m n m1 m2 %i %i %i %i",m,n,m1,m2);
				rang=alea_entier(0,N-1); // Modif alatoire de l'origine du lien
				if (rang==n) break;
				// n _doit_ informer deux mmoires au moins
				// sinon, on ne peut le dconnecter
				k=0;
				for (m3=0;m3<M;m3++) 
					if (LIENS.lien[m3][n]==-1 || LIENS.lien[m3][n]==2) k=k+1;
				if (k<2) break;
				n2=LIENS.lien[m][rang];
//printf("\n  rang %i n2 %i",rang,n2);
				switch(n2)
				{
				case 0: LIENS.lien[m][rang]=-1; break;
				case -1: break;
				case 1: LIENS.lien[m][rang]=2;break;
				case 2: break;
				}
				if (m2==-1) LIENS.lien[m][n]=0;
				else LIENS.lien[m][n]=1;
				break;

			case 1: // lien m -> n
printf("\n cas 1: m n m1 m2 %i %i %i %i",m,n,m1,m2);
				rang=alea_entier(0,M-1); // Modif alatoire de l'origine du lien
				if(rang==m) break;
				// m _doit_ informer deux particules au moins
				// sinon, on ne peut le dconnecter
				k=0;
				for (n3=0;n3<N;n3++) 
					if (LIENS.lien[m][n3]==1 || LIENS.lien[m][n3]==2) k=k+1;
				if (k<2) break;
				m2=LIENS.lien[rang][n];
				switch(m2)
				{
				case 0: LIENS.lien[rang][n]=1; 	break;
				case -1: LIENS.lien[rang][n]=2; break;
				case 1:  break;
				case 2: break;
				}
				if(m2==1) LIENS.lien[m][n]=0;
				else LIENS.lien[m][n]=-1;
				break;

			case 2: // liens m -> n et n ->m
				m1=2*alea_entier(0,1)-1; goto switch_m1;

			}
		}
	}
	break;

case 12: // "petit monde" par agrgation alatoire prfrentielle
		//  Note : l'algorithme suppose les liens bidirectionnels
 for (n=0;n<N;n++) LIENS.lien[n][n]=2; // Auto-liens (on doit avoir M>=N)

   for (n=0;n<N;n++) // Pour chaque nouveau noeud/particule
   {
		for (k=1;k<K;k++) // Pour chaque informatrice  ajouter ...
		{

			// Choix au hasard parmi celles non dj choisies
			// la proba tant proportionnelle au nombre de liens
			// dj issus de cette informatrice
			// Les liens tant bidirectionnels, ce nombre est gal
			// au nombre de liens entrants

			// Formation de la liste des possibles
//fprintf(f_exec,"\n n=%i, k=%i. Liens :",n,k);
//for (n1=0;n1<P[n].i_groupe_taille;n1++) fprintf(f_exec," %i",P[n].i_groupe[n1]);

			inform_taille=0;
			for (m=0;m<M;m++) // Parcours des informatrices potentielles
			{		
				if (LIENS.lien[m][n]>0) continue; // Dj informatrice
					inform[inform_taille]=m; // On ajoute n1  la liste
					inform_taille=inform_taille+1; 
			}

if(inform_taille==0) goto fin_inform_12;

//suite_possible_12:;

			// Comptage du nombre de leur liens et calcul des probabilits
			z=0;
			for (n1=0;n1<inform_taille;n1++) // Pour chaque informatrice possible
			{
				rang=inform[n1]; 
				n2=0; // Nombre de liens
				for (n1=0;n1<N;n1++) if (LIENS.lien[rang][n1]>0) n2=n2+1;

				z=z+n2; // Cumul

				zz=0;
				for (m=0;m<inform_taille;m++) // Pour chaque informatrice possible
				{
					rang=inform[m];
					n2=0; // Nombre de liens
					for (n3=0;n3<N;n3++) if (LIENS.lien[rang][n3]>0) n2=n2+1;
					zz=zz+n2/z;
				}
				inform_proba[n1]=zz; // probabilit cumule
			}


			// Choix alatoire
			z=alea(0,1);
			for (n1=0;n1<inform_taille;n1++)
			{
				if (z<inform_proba[n1]) {rang=inform[n1]; goto ajout_12;};
			}
			rang=inform_taille-1;
ajout_12:
//printf("\n %i %i",n,rang);
			// ajout du lien n => rang  et du lien inverse
			if (LIENS.lien[n][rang]==0) LIENS.lien[n][rang]=1; else LIENS.lien[n][rang]=2;
			if (LIENS.lien[rang][n]==0) LIENS.lien[rang][n]=1; else LIENS.lien[rang][n]=2;

		} // Fin boucle k sur les informatrices
fin_inform_12:;
   } // Fin boucle n sur les noeuds ajouts

	break;

case 13: // Double cycle (toile  N/(K-1) branches). Indpendant de K
printf("\n info_option %i  complter dans info_liens()\n",info_option);
FIN=1; break;
/*
      for (n=0;n<N;n++) // Premier lien circulaire
      {
         rang=n+1;    if(rang>N-1) rang=0;
         P[n].i_groupe[P[n].i_groupe_taille]=rang; // Lien direct n => rang
         P[n].i_groupe_taille=P[n].i_groupe_taille+1;
         P[rang].i_groupe[P[rang].i_groupe_taille]=n; // Lien inverse rang => n
         P[rang].i_groupe_taille=P[rang].i_groupe_taille+1;
       }

      for (n=0;n<N-1;n=n+2) // Deuxime lien circulaire
      {
         rang=n+2;    if(rang>N-2) rang=0;
         P[n].i_groupe[P[n].i_groupe_taille]=rang; // Lien direct n => rang
         P[n].i_groupe_taille=P[n].i_groupe_taille+1;
         P[rang].i_groupe[P[rang].i_groupe_taille]=n; // Lien inverse rang => n
         P[rang].i_groupe_taille=P[rang].i_groupe_taille+1;
       }
	break;
*/

case 14: // Ruban ferm. Indpendant de K. Chaque noeud a trois liens
			// N'est parfait que si N est pair
printf("\n info_option %i  complter dans info_liens()\n",info_option);
FIN=1; break;
/*
	if (N-2*(N/2)>0) pair=0; else pair=1;

      for (n=0;n<N;n=n+2) 
      {       	 		
		  rang=n+2;    
		  if(pair==1 && rang>N-1) rang=0;// Premier lien circulaire
		if(pair==0 && rang>N) rang=0;
         P[n].i_groupe[P[n].i_groupe_taille]=rang; // Lien direct n => rang
         P[n].i_groupe_taille=P[n].i_groupe_taille+1;
         P[rang].i_groupe[P[rang].i_groupe_taille]=n; // Lien inverse rang => n
         P[rang].i_groupe_taille=P[rang].i_groupe_taille+1;

         rang=n+1;    // Lien transverse
		 if (rang>N-1) rang=1;

         P[n].i_groupe[P[n].i_groupe_taille]=rang; // Lien direct n => rang

         P[n].i_groupe_taille=P[n].i_groupe_taille+1;
         P[rang].i_groupe[P[rang].i_groupe_taille]=n; // Lien inverse rang => n
         P[rang].i_groupe_taille=P[rang].i_groupe_taille+1;

		 n1=n+1;rang=n1+2; 
		 if (pair==1 && rang>N) rang=1; // Deuxime lien circulaire
		 if (pair==0 && rang>N-1) rang=1;
         P[n1].i_groupe[P[n1].i_groupe_taille]=rang; // Lien direct n1 => rang

         P[n1].i_groupe_taille=P[n1].i_groupe_taille+1;
         P[rang].i_groupe[P[rang].i_groupe_taille]=n1; // Lien inverse rang => n1
         P[rang].i_groupe_taille=P[rang].i_groupe_taille+1;
		 if (rang==1) goto fin_14;

       }
fin_14:
	break;
*/
	case 15: // Tribus circulaires dconnectes
for (n=0;n<N;n++) LIENS.lien[n][n]=2; // Auto-liens (on doit avoir M>=N)
      for (n=0;n<N;n=n+K)  // Formation des tribus
      {

		  for (n1=n;n1<n+K;n1++ ) // Tribu circulaire
         {
			rang=n1+1;
			if(rang>=n+K && rang<N) {rang=n;goto ajout_15;}

			if(rang==N &&  rang==n+2) break;;
			if (rang==N && rang>n+2) rang=n;

ajout_15:
			LIENS.lien[n1][rang]=1;
			LIENS.lien[rang][n1]=1;
         }
      }

      break;

	case 100: // Mixte 0 2
		if (alea(0,1)<0.5) goto case_0; else goto case_2;
}

//sauve_liens(f_graph_dot,1);

}
//============================================================= MAX
double max(double a,double b)

{
	if(a>=b) return a;
	return b;
}

//============================================================= MIN
double min(double a,double b)
{
	if(a<=b) return a;
	return b;
}

//============================================================= MA_CONTRAINTE
int	ma_contrainte(struct position x,int contrainte)
{/*
	contrainte imprative sous la forme g(x)<=0
	On teste si la position la respecte (valeur 1) ou non (valeur 0)

  */
int		d;
double	r,R;
int respect;

switch (contrainte)
{
case 1: // Sphre centre O rayon R

	R=10;
	r=0;
	for (d=0;d<x.taille;d++) r=r+x.x[d]*x.x[d];
	if (r<=R) 	
		respect=1; else respect=0;
	break;

case 2: // Hyperbolode centre O rayon R

	R=1;
	r=1;
	for (d=0;d<x.taille;d++) r=r*fabs(x.x[d]);
	if (r<=R) 	
		respect=1; else respect=0;
	break;

case 3: // Positivit
	r=0;
	for (d=0;d<x.taille;d++)
	{
		r=r+fabs(x.x[d])-x.x[d];
	}
	if (r<0) respect=0;else respect=1;
	break;

default:
	respect=1;
}



return respect;
}

//============================================================= MA_FONCTION
struct cout ma_fonction(struct position x, int fonction)
{/* Evalue la qualit (ventuellement multiple) 
    de la fonction  minimiser  la position x

	En gnral, le premier lment de la qualit est la valeur de la fonction 
objectif
	et les autres les mesures d'insatisfaction des ventuelles contraintes 
indicatives

  AJOUTEZ VOTRE PROPRE FONCTION
  */
double	alpha, beta;
double      c;
struct cout C;
int    D,d;
double delta;
double f, f1,f2,p,som1,som2,xd;
double	x1,x2,x3,x4;
double      y;
double	zz;

double two_pi=6.283185307;
double	E=2.718281828;
double sqr2;

static  double u[4]={10,20,30,40};
static double v[4] = {19,643,8360,20687};


nb_eval=nb_eval+1;
D=x.taille;
C.taille=x.C.taille;

switch (fonction)
{
case 1: // Parabole
	f=0;
	for(d=0;d<D;d++) f=f+x.x[d]*x.x[d];
	C.c[0]=f;
	break;

case 2: // Utiliser un xmin >=0
	f=0;
	for(d=0;d<D;d++) f=f+sqrt(x.x[d]);
	C.c[0]=f;
	break;

case 30: // ANCIENNE VERSION. Fonction Alpine 1. Min 0 en (0,0 ...0)	
	f=1;
	for( d=0;d<D;d++)
	{
		f=f*sqrt(fabs(x.x[d]*sin(x.x[d])));
	}
	C.c[0]=f;
	break;

case 3: // Fonction Alpine. Min 0 en (0,0 ...0)
	f=0; 
	for( d=0;d<D;d++)
	{
		zz=x.x[d];
		f=f+fabs(zz*sin(zz)+0.1*zz); // Alpine 2 (plusieurs minimums globaux)
	//	f=f+sqrt(fabs(x.x[d]*sin(x.x[d]))); // Alpine 3 (plusieurs minimums globaux)
	//	f=f+fabs(zz*sin(zz)+1.1*zz); // Alpine 4 (un seul minimum global)

	}

	C.c[0]=f;
	break;

case 4: // Rosenbrock, fonction Banane. Min 0 en (1, ...1)
	f=0;
	for (d=0;d<D-1;d++)
	{
		xd=1-x.x[d];
		f=f+xd*xd;
		xd= x.x[d]*x.x[d]-x.x[d+1];

		f=f+100*xd*xd;
	}
	C.c[0]=f;
//C.c[0]=1-1/(1+f);
	break;


case 5:  // Ackley
	som1=0;som2=0;
	for (d=0;d<D;d++)

	{
		xd=x.x[d];
		som1=som1+xd*xd;
		som2=som2+cos(two_pi*xd);
	}
	f=(-20*exp(-0.2*sqrt(som1/(double)D))-exp(som2/(double)D)+20+E);
	C.c[0]=f;
	break;

case 6: // Griewank
	f=0;
	p=1;
	for (d=0;d<D;d++)
	{
		xd=x.x[d]-100;
		f=f+xd*xd;
		p=p*cos(xd/sqrt(d+1));
	}
	f=f/4000 -p +1;
	C.c[0]=f;
	break;

case 7 : // abs(sin(x)) +abs(x)
	// D=1
	alpha=(2/pi)*0.6;
	f=fabs(sin(x.x[0]))+alpha*x.x[0];
	C.c[0]=f;
	break;

case 8 : // abs(sin(x))  et contrainte indicative  minimiser abs(x)
	// D=1
	C.c[0]=fabs(sin(x.x[0]));
	C.c[1]=x.x[0];
	break;

case 9: 
	f=fabs(32767+0.001-x.x[0]);
	C.c[0]=f;
	break;

case 10: // Tripod function (Louis Gacogne)

	// on [-100, 100], min 0 on (0,-50)
	x1=x.x[0];
	x2=x.x[1];

	if(x2<0)
	{
		f=fabs(x1)+fabs(x2+50);	
	}
	else
	{
		if(x1<0)
			f=1+fabs(x1+50)+fabs(x2-50);
		else
			f=2+fabs(x1-50)+fabs(x2-50);
	}
	C.c[0]=f;
	break;

case 11: // Sphre dcale. Min 1 en (1 1 1 ...1)
	f=0;
	for(d=0;d<D;d++) f=f+(x.x[d]-1)*(x.x[d]-1);
	C.c[0]=f;
	break;

case 12: // Ajustement de modle
	x1=x.x[0];
	x2=x.x[1];
	f=0;
	for (d=0;d<4;d++)
	{
		zz=x1*pow(u[d],x2)-v[d];
		f=f+zz*zz;
	}
	C.c[0]=sqrt(f);
	break;

case 13: // Champ minimum entre deux stations
		// (somme de deux champs sinusodaux dcroissants)
         // Chercher le min sur [0  2,5] => x=0,455, f=0,067
	x1=x.x[0];
	f1=exp(-x1)*(1+sin(10*x1));
	x1=fabs(x1-2.7);
	f2=exp(-x1)*(1+sin(10*x1));
	C.c[0]=f1+f2;
	break;

case 14: // Surface sphrique dcale de rayon 1
	f=0;
	for(d=0;d<D;d++) f=f+(x.x[d]-1)*(x.x[d]-1);
	C.c[0]=fabs(f-1);
	break;

case 15: // sin(x)
	f=0;
	for(d=0;d<D;d++) f=f+fabs(sin(x.x[d]));
	C.c[0]=f;
	break;

case 16: // x^alpha, alpha<1 sur [-10 10]
	alpha=0.285424363; // Difficult 500 en dimension 10
	alpha=0.369034598; // Difficult 390
	f=0;
	for(d=0;d<D;d++) f=f+pow(fabs(x.x[d]),alpha);
 
	C.c[0]=f;
	break;

case 17: //Spring design benchmark problem (T. Ray)
		// 0.25 <= x1 <=1.3
		// 0.05 <= x2 <= 2.0
		// 2    <= x3 <= 15

	x1=x.x[0]; x2=x.x[1]; x3=x.x[2];

	f=(x3+2)*x1*x2*x2 ;// Fonction

	zz= 1-x1*x1*x1*x3/(71785*x2*x2*x2*x2);
	f=f+ fabs(zz+fabs(zz)); // Contrainte 1, zz<=0

	//if (zz>0) f=f+0.007;
	zz=x2*x2*x2*(x1-x2);
	if (fabs(zz)<=zero) {f=f+1/zero; goto case_17;}

	zz=(4*x1*x1-x1*x2)/(12566*zz)+1/(5108*x2*x2)-1;
	f=f+ fabs(zz+fabs(zz)); // Contrainte 2, zz<=0

case_17:

	zz=1-140.45*x2/(x1*x1*x3*x3*x3);
	f=f+ fabs(zz+fabs(zz)); // Contrainte 3, zz<=0

	zz=(x1+x3)/1.5 -1;
	f=f+ fabs(zz+fabs(zz)); // Contrainte 4, zz<=0

	C.c[0]=f;		 
	break;


case 18: // Three-Bar Truss Design benchmark (T. Ray)
		// 0 <= x1 <= 1,  0 <= x2 <= 1

	x1=x.x[0]; x2=x.x[1];
	alpha=100000000000;
	beta=1000;
	sqr2=sqrt(2);

	f=(2*sqr2*x1+x2)*100;

	C.c[0]=f;

	zz=2*(sqr2*x1+x2)/(sqr2*x1*x1+2*x1*x2)-2;
	C.c[1]=fabs(zz+fabs(zz)); // Contrainte 1, zz<=0

	zz=2*x2/(sqr2*x1*x1+2*x1*x2)-2;
	C.c[2]=fabs(zz+fabs(zz)); // Contrainte 2, zz<=0

	zz=2/(x1+sqr2*x2)-2;
	C.c[3]=fabs(zz+fabs(zz)); // Contrainte 3, zz<=0

	C.c[0]=	C.c[0]+beta*C.c[1]+alpha*C.c[2]+alpha*C.c[3]; // En mono objectif

	break;
   
  case 20: // Pressure vessel (Ivan Zelinka)
	x1=x.x[0];
	x2=x.x[1];
   	x3=x.x[2];
	x4=x.x[3];

	delta=0.0625;
   f=0.6224*x1*x3*x4 + 1.7781*x2*x3*x3 + 3.1611*x1*x1*x4 + 19.84*x1*x1*x3;

  y=0.0193*x3-x1; if ( y>0) {c= 1+pow(10,10)*y;  f=f*c*c; }
  y=  0.00954*x3-x2; if (y>0) {c=1+y; f=f*c*c; }

  y = 750*1728-pi*x3*x3*(x4+(4.0/3)*x3);  if (y>0) {c=1+y; f=f*c*c;} 


	f1=fabs((x1-delta)*(x2-delta)); 

	C.c[0]=f;
	C.c[1]=f1;
    break;

  case 21: // XOR
 C.c[0]= ANNXor(x);
 break;

  case 22: // 4 bit parity
 C.c[0]= ANNParity4(x);
 break;

 case 25: //Sin Times Sin
  	C.c[0]=ANNSINSIMP(x);
   break;

 case 99: // Test	
   f=0;
	for(d=0;d<D;d++) f=f+pow(x.x[d],10);
	C.c[0]=f;
	break;

}

return C;
}

//============================================================= PARAM
struct param param(FILE *f)
{
	struct param p;
	float z;

	fscanf(f,"%i",&p.adapt_c1);
	fscanf(f,"%i",&p.confin_interv);
	fscanf(f,"%i",&p.equivalence); fscanf(f,"%i",&p.equivalence_floue);

	fscanf(f,"%i",&p.K1);fscanf(f,"%i",&p.K2);
	fscanf(f,"%i",&p.info_option);fscanf(f,"%i",&p.info_topologie);
	fscanf(f,"%i",&p.fige);

	fscanf(f, "%i",&p.M1); fscanf(f, "%i",&p.M2);
	fscanf(f,"%i",&p.mouv_option);
	fscanf(f,"%f",&z);p.unif=z; 

	fscanf(f,"%i",&p.N1);fscanf(f,"%i",&p.N2);
	fscanf(f,"%f",&z);p.phi1=z;fscanf(f,"%f",&z);p.phi2=z;fscanf(f,"%f",&z);p.d_phi=z;
	
	fscanf(f,"%f",&z); p.pr=z;

   fscanf(f,"%i",&p.reorg); // 1 si reorganisation de  l'essaim-memoire, 0 sinon
   fscanf(f,"%i",&p.reine); // 1 si utilisation d'une reine, 0 sinon
   fscanf(f,"%i",&p.parall);   // 1 si simulation de parallelisme, 0 sinon
   fscanf(f,"%i",&p.energie); // Juste pour info, 1 => sauvegarde les nergies sur f_energ

	return p;
}
//============================================================= PROBLEME
struct probleme probleme(FILE *f)
{
/*

NOte : x_n est une variable globale

  */
	
	int	d;
	struct probleme P;
	float	z1,z2,z3;
FIN=0;
fscanf(f,"%i ",&P.n_exec_max);// Nombre total d'excutions
fscanf(f,"%i ",&P.eval_max);// Nombre maximum d'valuations
fscanf(f,"%i ",&P.sauve_exec);// >0 =>  sauvegarde sur exec.txt
fscanf(f,"%i ",&P.fonction); // Code du problme
fscanf(f,"%i ",&P.contrainte); // Code de contrainte imprative
fscanf(f,"%i ",&P.C_taille);// Nombre de fonctions  optimiser simultanment

fscanf(f,"%f ",&z1);// Prcision souhaite
P.eps=z1;
fscanf(f,"%f ",&z2);// Cout total  atteindre,  la prcision prs
P.fmin=z2;

fscanf(f,"%i ",&P.D);// Espace de recherche. Dimension
for (d=0;d<P.D;d++) // Espace de recherche. Intervalles et granularit
{
	fscanf(f,"%f %f %f",&z1,&z2,&z3);

	P.xmin[d]=z1; P.xmax[d]=z2; P.delta[d]=z3;
}


if (P.contrainte>0) // On donne un point qui respecte la contrainte
{
	for (d=0;d<P.D;d++)
	{
		fscanf(f,"%f",&z1);
		x_n.x[d]=z1; 
	}
	x_n.taille=P.D;

	// Vrification
	if (ma_contrainte(x_n,P.contrainte)==0)
	{
		printf("\n ATTENTION. La position donne ne respecte pas la contrainte");
		FIN=1;
	}
}

return P;
}

 // ------------------------------------------------------------------------- REGRANUL
double	regranul(double x,double granul)
{ // Modify a value according to the granularity of the search space

if (granul<presquezero) return x;// Pseudo-continuous 
								// (depending on the machine)

if (x>=0) return (granul*floor (x/granul+0.5)); //"1/granul" is the minimum 
												// distance between two points

return (-granul*floor(-x/granul+0.5));
}

//============================================================= RESPECT_CONTRAINTE
struct position	respect_contrainte(struct position pos, struct position x_neg,int contrainte)
{
/*
Ajuste la position pos pour respecter la contrainte
x_n est une position qui respecte la contrainte 
La nouvelle position n'est pas r-value ici, elle le sera plus tard 
TRAVAIL EN COURS pour le respect par dichotomie
*/
	int d;
	double dist;
	int	respect;
	struct position xn,xp;

	xn=x_neg;

//respect=ma_contrainte(xn,contrainte);
/*
if (respect==0)
{
	printf ("\n Erreur dans respect_contrainte()");
	FIN=1;
//infinite:;goto infinite;
	return pos;
}
*/
//fprintf(f_exec,"\n respect contrainte");

//fprintf(f_exec," x_neg %f %f",xn.x[0],xn.x[1],respect);
	xp=pos;

	respect=ma_contrainte(xp,contrainte);

//fprintf(f_exec,"\n %f %f => %i",xp.x[0],xp.x[1],respect);
	while (respect==0)
	{
		for (d=0;d<pos.taille;d++)
		{
			xp.x[d]=(xn.x[d]+xp.x[d])/2;

		}
		respect=ma_contrainte(xp,contrainte);
//fprintf(f_exec,"\n %f %f => %i",xp.x[0],xp.x[1],respect);
	dist=0;
	for (d=0;d<pos.taille;d++) dist=dist+(xn.x[d]-xp.x[d])*(xn.x[d]-xp.x[d]);
	if (dist<=0.000000001) return xp; // Pour pallier l'imprcision numrique

										// des comparaisons de deux nombres
	// Attention, sans ce test, le programme peut boucler.
	}

	return xp;

}

//============================================================= SAUVE_LIENS
void	sauve_liens(FILE *f, int option)
{
	/*
Sauvegarde les liens au format DOT pour visualisation future 
(par exemple avec Graphviz)
  */
int	m,n;

/*
// Sauvegarde de vrification
for (m=0;m<M;m++)
{
	fprintf(f,"\n");
	for (n=0;n<N;n++) fprintf(f,"%i ",LIENS.lien[m][n]);
}
*/

switch (option)


{
case 1:
	fprintf(f,"digraph G {");
	fprintf(f,"\n  node [shape=ellipse,style=filled,color=grey50,width=0.5,height=0.5]; \n{");// Essaim-mmoire
	for (m=0;m<M;m++) fprintf(f,"\n m%i  ;",m+1); 
	fprintf(f,"\n }");

	fprintf(f,"\n  node [shape=ellipse,style=filled,color=lightgrey,width=0.5,height=0.5]; \n{");// Essaim
	for (n=0;n<N;n++) fprintf(f,"\n %i ;",n+1);
	
	fprintf(f,"\n }");

	fprintf(f,"\n graph [splines=true overlap=false]");
 

      for (m=0;m<M;m++)// Liens essaim-mmoire EM <=> essaim-explorateur EX
      {
		  for (n=0;n<N;n++)
		  {
			  if (LIENS.lien[m][n]>0) fprintf(f,"\n m%i -> %i;", m+1,n+1);// EM=>EX
			  if (LIENS.lien[m][n]<0 || LIENS.lien[m][n]==2) fprintf(f,"\n %i -> m%i;", n+1,m+1);// EX=>EM
		  }
		}

	fprintf(f,"}");
	printf("\n Structure de liens sur graph_dot.txt");
	break;

case 2: // Reprsentation simplifie pour graphes avec N=M
	fprintf(f,"digraph G {");

	fprintf(f,"\n  node [shape=ellipse,style=filled,color=lightgrey,width=0.5,height=0.5]; \n{");// Essaim
	for (n=0;n<N;n++) fprintf(f,"\n %i ;",n+1);
	
	fprintf(f,"\n }");
	fprintf(f,"\n graph [splines=true overlap=false]");
 
	for (m=0;m<M;m++)
	{
	 for (n=0;n<N;n++)
	{
		if(n==m) continue;		  
		 if (LIENS.lien[m][n]!=0) fprintf(f,"\n %i -> %i;", m+1,n+1);

	}
	}

	fprintf(f,"}");
	printf("\n Structure de liens sur graph_dot_simple.txt");
	break;
}
}

//============================================================= SCALAIRE
double	scalaire(struct vecteur v1,struct vecteur v2)
{
// Produit scalaire de deux vecteurs (supposs de mme taille)
int	d;
double	s;

s=0;
for (d=0;d<v1.taille;d++) s=s+v1.v[d]*v2.v[d];
return s;
}

//============================================================= ZERO_
double   zero_(double valeur)

{ /* Tronque   "valeur" selon le niveau de precision requis
   La variable zero est globale
   */
   if (fabs(valeur)<zero)
   {
      if (valeur<0)
        return -zero;
      else return zero;
   }
   return valeur;
}


//================================================== KISS
/*

 the idea is to use simple, fast, individually promising
 generators to get a composite that will be fast, easy to code
 have a very long period and pass all the tests put to it.
 The three components of KISS are
        x(n)=a*x(n-1)+1 mod 2^32
        y(n)=y(n-1)(I+L^13)(I+R^17)(I+L^5),
        z(n)=2*z(n-1)+z(n-2) +carry mod 2^32
 The y's are a shift register sequence on 32bit binary vectors
 period 2^32-1;
 The z's are a simple multiply-with-carry sequence with period
 2^63+2^32-1.  The period of KISS is thus
      2^32*(2^32-1)*(2^63+2^32-1) > 2^127
*/



static ulong kiss_x = 1;
static ulong kiss_y = 2;
static ulong kiss_z = 4;
static ulong kiss_w = 8;
static ulong kiss_carry = 0;
static ulong kiss_k;
static ulong kiss_m;


void seed_rand_kiss(ulong seed) 
{
    kiss_x = seed | 1;
    kiss_y = seed | 2;
    kiss_z = seed | 4;
    kiss_w = seed | 8;
    kiss_carry = 0;
}

ulong rand_kiss() 
{
    kiss_x = kiss_x * 69069 + 1;
    kiss_y ^= kiss_y << 13;
    kiss_y ^= kiss_y >> 17;
    kiss_y ^= kiss_y << 5;
    kiss_k = (kiss_z >> 2) + (kiss_w >> 3) + (kiss_carry >> 2);
    kiss_m = kiss_w + kiss_w + kiss_z + kiss_carry;
    kiss_z = kiss_w;
    kiss_w = kiss_m;
    kiss_carry = kiss_k >> 30;
    return kiss_x + kiss_y + kiss_w;
}


//======================================================

